import time
import pdb


#-------------------------------------------------------------------------------
#method for calculating checksum
def CheckSum(cmd):
        
    
    for index in range(0,len(cmd),2):
        #calculate xor for firt 2 bytes
        if index == 0:
           temp1 = cmd[index:index+2]
           temp2 = cmd[index+2:index+4]
           xor = hex(int(temp1,16)^int(temp2,16))
        elif index == 2: #skip for the 2nd byte
           continue
        else: #continue the loop until end of the bytes
           temp1 = xor
           temp2 = cmd[index:index+2]
           xor = hex(int(temp1,16)^int(temp2,16))

        if len(xor) != 4:
            xor = '0x0%s' %xor[2] 
            

    cs = xor[2:4]
    hexcmd = cmd+cs
    return hexcmd

#-------------------------------------------------------------------------------

#method for Serial port communcation 
    
def SerialComm(ser, cmd):
    
    while True:
        ser.write(cmd) #Get EPC
        data_hex = ReadSerial(ser)
        ser.flushInput()
        search = data_hex.find('524645', 10)
        if search == -1:
                datahex = data_hex
        else:
                datahex = data_hex[search:]

        break
        
    return datahex
#-------------------------------------------------------------------------------

#method for reading the serial data
    
def ReadSerial(ser):
    data = ''
    while True:
        while ser.inWaiting():
            data = ser.readline() #Read data
            data_hex= data.encode("hex")#print the hex value
            
        if not data:
            continue
        else:    
            break
    
    return data_hex
#-------------------------------------------------------------------------------

#method to convert Hex string into a byte string
def HexToByte(hexStr):

    
    """
    Convert a string hex byte values into a byte string. 
    """   
    bytes = []
    
    for i in range (0,len(hexStr),2):
        bytes.append( chr( int (hexStr[i:i+2], 16)))
                           
    return ''.join( bytes )
    
#-------------------------------------------------------------------------------

        
#method to print the hex value

def hex_data(data):
    hexdata = data.decode("hex")
    return hexdata

#-------------------------------------------------------------------------------


